/* Copyright (c) 1996 by Stanford University.  All Rights Reserved */

/***************************************************************************
   NAME

   PURPOSE
     
   NOTES
     
   AUTHOR
     David Hsu  
   
     dyhsu@cs.stanford.edu
     http://robotics.stanford.edu/~dyhsu 
                  
   HISTORY

***************************************************************************/


#include "cspace.H"
#include "utilities.H"

/*----------------------- class Cspace -------------------------------*/

/* res
 *   set the resolution of the cspace
 *
 *   incr : resulution in workspace
 *   param: a scaling const, usually the max radius of the robot
 */
/*
void Cspace::res(Coord incr, Coord param)
{
    // translation part
    for (int i=0; i < 3; i++)
	step[i] =  incr;

    // rotation part
    for (; i<DIM; i++) 
	step[i] = incr /( M_PI * param);
}

void Cspace::ires(Coord incr, Coord param)
{
    // translation part
    for (int i=0; i < 3; i++)
	istep[i] =  incr;

    // rotation part
    for (; i<DIM; i++) 
	istep[i] = incr /( M_PI * param);
}
*/
    
istream& operator>> (istream& is, Cspace& b)
{
    for (int i=0; i < DIM; i++)
	is >> b.l[i] >> b.r[i];
    return is;
}

ostream& operator << (ostream& os, Cspace& b)
{
    for (int i=0; i < DIM; i++)
	os << i << " : "  << b.l[i] << ' '  << b.r[i] << endl;
    return os;
}


/*------------------------- class SampleBox ----------------------------*/

/* SampleBox
 *    calculate the size of sampling box 
 *
 *    param : a scaling const, usu. the max radius of robot
 */
    
SampleBox::SampleBox(float len, Coord param, Cspace& csp)
{
    for (int j=0; j<3; j++)
	q[j] = MIN(len, csp.r[j] - csp.l[j]);
    for (; j<DIM; j++) 
	q[j] = MIN(2* len/ param, csp.r[j] - csp.l[j]) ;
}
